#include "struttura.h"
#include <iostream>
#include <cstring>

using namespace std;

void leggi_elenco(Azienda lista[], int n) {

    for (int i = 0; i < n; i++) {
        bool corretto;

        cout << endl;
        cout << "Inserire dati per azienda n. " << i + 1 << endl;
        cout << "Nome: ";
        cin.ignore();
        cin.getline(lista[i].nome, 32);

        // Lettura tipologia
        do {
            cout << "Tipologia azienda: ";
            cin >> lista[i].tipo;
            if ((strcmp(lista[i].tipo, "meccanica") == 0) || 
                    (strcmp(lista[i].tipo, "tessile") == 0) ||
                    (strcmp(lista[i].tipo, "elettronica") == 0) || 
                    (strcmp(lista[i].tipo, "farmaceutica") == 0))
                corretto = true;
            else
                corretto = false;
        } while (!corretto);
        
        cout << "Numero dipendenti: ";
        cin >> lista[i].numdipendenti;
        
        cout << "Capitale sociale: ";
        cin >> lista[i].capitale;
    } // end FOR
    
    return;
}

void modifica_elenco(Azienda listain[], int &nin, float t, char tipo[], Azienda listaout[],int &nout){
    int i;
    
    nout = 0;
    i = 0;
    
    while(i < nin){
        if(strcmp(listain[i].tipo,tipo)==0){
            // L'elemento è della tipologia richiesta
            if(listain[i].capitale > t){
                // L'elemento va aggiunto in coda al nuovo elenco
                listaout[nout] = listain[i];
                nout++;
            }
            
            // L'elemento va ora eliminato dall'elenco iniziale
            // si fanno scorrere gli elementi dell'elenco
            // di una posizione verso l'inizio, a partire
            // dalla posizione dell'elemento da eliminare
            for(int j=i; j<nin-1; j++)
                listain[j]=listain[j+1];
            
            // Non si incrementa l'indice
            // perchè ora in posizione i c'è
            // un nuovo elemento da verificare
            // Si decrementa il riempimento
            // perchè l'elenco contiene un elemento
            // in meno
            nin--;
        }
        else
            // In posizione i non c'è un elemento
            // della tipologia richiesta
            // Si incrementa l'indice per andare a 
            // considerare l'elemento successivo
            i++;
    }
    
    return;
}
void ordina_elenco(Azienda lista[], int n){
    int last,end;
    bool fattoswap;
    
    last = 0;

    do{
        fattoswap = false;
        end = last;
        for (int i = n - 1; i > end; i--)
            if (strcmp(lista[i].nome,lista[i - 1].nome) < 0) {
                Azienda appo = lista[i];
                
                lista[i] = lista[i-1];
                lista[i-1] = appo;
                
                last = i;
                fattoswap = true;
            }
    }while(fattoswap);
    
    return;
}


void stampa_elenco(Azienda lista[],int n){
    for(int i=0; i<n; i++){
        cout << "\nAzienda n. " << i+1 << endl;
        cout << "Nome: " << lista[i].nome << endl;
        cout << "Tipologia: " << lista[i].tipo << endl;
        cout << "Numero dipendenti: " << lista[i].numdipendenti << endl;
        cout << "Capitale sociale: " << lista[i].capitale << endl;
    }
}

